RSpec.describe Olympic::Rating::Glicko do
  OS = OlympicSpec

  def source_for(team)
    OS::Source.create(source: team)
  end

  subject { described_class.new(unit) }
  let(:unit) { OS::Team.
    create(name: "Alpha", rating: 1500, derivation: 200) }
  let(:beta) { OS::Team.
    create(name: "Beta", rating: 1400, derivation: 30) }
  let(:charlie) { OS::Team.
    create(name: "Charlie", rating: 1550, derivation: 100) }
  let(:delta) { OS::Team.
    create(name: "Delta", rating: 1700, derivation: 300) }
  let(:matches) { [
    OS::Match.create(incoming: [source_for(unit), source_for(beta)], winner: unit),
    OS::Match.create(incoming: [source_for(unit), source_for(charlie)], winner: unit),
    OS::Match.create(incoming: [source_for(unit), source_for(delta)], winner: unit)] }

  context "#update" do
    it "updates the unit" do
      expect { subject.update(matches) }.to_not raise_error
      expect(unit.rating).to be_within(2).of 1464
      expect(unit.derivation).to be_within(1).of 151.4
    end
  end
end
